<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Mandelbrot!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>       

    <section>
        <title>BPMN</title>

	<para>
		A BPMN egy folyamatmodellezési szabvány, amely lehetővé teszi könnyen értelmezhető folyamatábrák létrehozását és megosztását. Ezek a folyamatábrák alkalmasak a teljes üzleti folyamat minden lépésének vizuális modellezésére.
        </para>

        <para>
		Célja a folyamatban szereplő tevékenységek megfelelő sorrendbe szervezése és a tevékenységekhez kapcsolódó információk ábrázolása.
        </para>

        <para>
            Szintjei:
        </para>

        <para>
            Folyamattérkép (Process Map)
        </para>

        <para>
            Folyamatleírás (Process Description)
        </para>

        <para>
            Folyamatmodell (Process Model)
        </para>

	<figure>
            <title>BPMN</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/prog2/bpmn.png" scale="30" />
                </imageobject>
                <textobject>
                    <phrase>BPMN</phrase>
                </textobject>
            </mediaobject>
        </figure>

	<para>
		A BPMN bemutatására egy saját diagrammot készítettem, ami egy étteremben való ételrendelést mutatja be. A diagrammon jól látszódik a műveletek logikai háttere, hogy éppen milyen kommunikáció zajlik a vendég és a pincér között. Továbbá láthatóak az elágazások, amik különböző eredményeket adnak bizonyos feltételek teljesülésekor. Ezáltal az összes lehetőség kezelve van.
	</para>


    </section>

    <section>
        <title>EPAM: Neptun tantárgyfelvétel modellezése UML-ben</title>

	<para>
		A következő feladatban az általunk használt Neptun rendszer tárgyfelvétel minimális részét készítettem el UML-ben. A feladat megoldásához létrehoztam 4 darab osztályt.
        </para>

        <para>
		Ezek közül a legnagyobb osztály, ami a legtöbb adatot tartalmazza a 'Subjects' osztály. Itt rengeteg adat van megadva, amit szükséges a hallgatók számára megadni, illetve feljegyezni, a tárgyfelvétel sikeres működése érdekében.
        </para>

        <para>
		A 'Teacher' osztály egy ősosztály, amiben csak a tanár neve szerepel. Ebből az osztályból örököltettem le a 'Student' osztályt, hiszen a hallgatók is rendelkeznek azzal a tulajdonsággal, amivel a tanárok azaz van nevük. Ide felvettem a Neptunkódot is, mint plusz adatot és az évfolyamot.
        </para>

        <para>
            Végül a fő osztályban (Main) látható a main metódusunk.
        </para>
        <para>
            A létrehozott UML- diagramm:
        </para>


	<figure>
            <title>Neptun tárgyfelvétel UML diagram</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/prog2/neptun.png" scale="75" />
                </imageobject>
                <textobject>
                    <phrase>Neptun tárgyfelvétel UML diagram</phrase>
                </textobject>
            </mediaobject>
        </figure>

    </section>


    <section>
        <title>EPAM: OO modellezés</title>

	<para>
            Leírás forrása: <link xlink:href="https://medium.com/better-programming/kiss-dry-and-code-principles-every-developer-should-follow-b77d89f51d74">https://medium.com/better-programming/kiss-dry-and-code-principles-every-developer-should-follow-b77d89f51d74</link>
        </para>

	<para>
		SOLID alapelvek
	</para>

	<para>
		- Single-responsibility principle (Egy felelősség elv)
	</para>
	<para>Egy osztály vagy modul egy, és csak egy felelősséggel rendelkezzen (legyen egy oka a változásra).</para>

	<para>
		- Open–closed principle (Nyílt/zárt elv)
	</para>
	<para>Egy osztály, vagy modul, legyen nyílt a kiterjesztésre, de zárt a módosításra.</para>

	<para>
		- Liskov substitution principle (Liskov helyettesítési elv)
	</para>
	<para>Minden osztály legyen helyettesíthető a leszármazott osztályával anélkül, hogy a program helyes működése megváltozna.</para>

	<para>
		- Interface segregation principle (Interfész elkülönítés elve)
	</para>
	<para>Több specifikus interface jobb, mint egy általános.</para>

	<para>
		- Dependency inversion principle (A függőség megfordítása)
	</para>
	<para>A kódod függjön absztrakcióktól, ne konkrét implementációktól.</para>


	<para>
		KISS
	</para>

	<para>
		Keep It Simple Stupid
	</para>

	<para>
		Amikor egy program mérete növekszik, a kód bonyolultsága is növekszik. Ez nehezít a hibakeresésben és az összetett kód hibakeresése egy rémes feladat. A KISS elv kimondja, hogy mindig egyszerűnek kell tartani a kódot. Ha összetett kódrészlet van, mindig próbáljunk kisebb, karbantarthatóbb kódokra bontani.
	</para>
	
	<para>
		Nehezebb egyszerű tiszta kódot írni, mint összetett kódot. Minél többet fejlődünk fejlesztőként, kódíróként, annál tisztább és értelmesebb a kódunk.
	</para>

	<para>
		DRY
	</para>

	<para>
		Don’t Repeat Yourself
	</para>

	<para>
		A DRY elv döntő fontosságú az egyszerű és könnyen módosítható kód írásakor. Az ismételt kód gyakori hiba a programozók körében. Ez az elv kimondja, hogy egy kódrészletet a forráskód egyetlen helyén kell megvalósítani. Ha azt észleljük, hogy ugyanazt a kódrészletet írjuk újra és újra, akkor megszegjük az elvet.

	</para>
	
	<para>
		A DRY kód ellentéte a WET kód: mindent kétszer írj.
	</para>

	<para>
		YAGNI
	</para>

	<para>
		You Aren’t Gonna Need It
	</para>

	<para>
		Van, amikor fel kell készülnünk a jövőre, de nem a programozásra. Az emberek hajlamosak olyan kódot írni, amelyre a jövőben szükségük lehet, de jelenleg nem. Az ilyen típusú kódok szükségtelenül növelik a program méretét, mivel az írott kódot soha nem hajtódik végre. Sőt, a legtöbb programozó a jövőben soha nem használja ezt a kódot. A programozóknak ez a szokása feleslegesen felfújja a kódot.
	</para>	

	<para>
		Ez az elv kimondja, hogy addig nem szabad valamit megvalósítani, amíg azt nem szükséges. Ez egy olyan elv, amelyet minden fejlesztőnek, programozónak be kell tartania.
	</para>

	<para>
		SoC
	</para>

	<para>
		Separation of Concerns
	</para>

	<para>
		A SoC alapelve a saját vállalkozásod gondozása - szó szerint. Ez az elv azt tanácsolja, hogy ossza fel összetett kódját különböző szakaszokra vagy tartományokra. Minden szakasz független egymástól, és ezért minden szakasz önállóan kezelhető. Emellett könnyebbé válik a kód karbantartása, frissítése és újrafelhasználása.
	</para>

	<para>
		A SoC egyik jó példája az MVC Architecture (model-view-controller). Ez három programra különíti el a programot: az adatokra (modell), a logikára (vezérlő) és arra, amit a végfelhasználó lát (nézet). Az MVC-t nagymértékben megvalósítják a modern kori keretek között.
	</para>
	
	<figure>
            <title>MVC Architecture</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/prog2/mvc.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>MVC Architecture</phrase>
                </textobject>
            </mediaobject>
        </figure>

    </section>

</chapter>                
